#!/usr/bin/env lua
local forward
local worst_forward = 1.0/0.0
local state = nil
local done
for line in io.lines() do
  if line:find(" RADIATION PATTERNS ") then
    state = "gain"
    forward = -1.0/0.0
    done = false
  elseif state == "gain" then
    local theta, phi, gain = line:match("^ +([-+0-9.Ee]+) +([-+0-9.Ee]+) +[-+0-9.Ee]+ +[-+0-9.Ee]+ +([-+0-9.Ee]+) ")
    if gain then
      theta = tonumber(theta)
      phi = tonumber(phi)
      gain = tonumber(gain)
      if theta == 90 and phi == 90 then
        forward = math.max(forward, gain)
      end
      done = true
    elseif done then
      if forward > -1.0/0.0 then
        worst_forward = math.min(worst_forward, forward)
      end
      state = nil
    end
  end
end
print(worst_forward)
