#!/usr/bin/env lua
local worst_loss = 0.0
local forward
local worst_forward = 1.0/0.0
local state = nil
local done
for line in io.lines() do
  if line:find(" ANTENNA INPUT PARAMETERS ") then
    state = "impedance"
    done = false
  elseif line:find(" RADIATION PATTERNS ") then
    state = "gain"
    forward = -1.0/0.0
    done = false
  elseif state == "impedance" then
    local real, imag = line:match("^ +[-+0-9.Ee]+ +[-+0-9.Ee]+ +[-+0-9.Ee]+ +[-+0-9.Ee]+ +[-+0-9.Ee]+ +[-+0-9.Ee]+ +([-+0-9.Ee]+) +([-+0-9.Ee]+) ")
    if real then
      real, imag = tonumber(real), tonumber(imag)
      real = real / 50
      imag = imag / 50
      local loss = math.log(4*real / (real*real + 2*real + imag*imag + 1), 10) * 10
      worst_loss = math.min(worst_loss, loss)
      done = true
    elseif done then
      state = nil
    end
  elseif state == "gain" then
    local theta, phi, gain = line:match("^ +([-+0-9.Ee]+) +([-+0-9.Ee]+) +[-+0-9.Ee]+ +[-+0-9.Ee]+ +([-+0-9.Ee]+) ")
    if gain then
      theta = tonumber(theta)
      phi = tonumber(phi)
      gain = tonumber(gain)
      if theta == 90 and phi == 90 then
        forward = math.max(forward, gain)
      end
      done = true
    elseif done then
      if forward > -1.0/0.0 then
        worst_forward = math.min(worst_forward, forward)
      end
      state = nil
    end
  end
end
print(worst_forward + worst_loss)
